freedombone-mesh-batman 17KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Used to enable or disable batman mesh protocol on wlanX
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2015-2017 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. PROJECT_NAME='freedombone'
  31. COMPLETION_FILE=/root/${PROJECT_NAME}-completed.txt
  32. # hotspot passphrase must be 5 characters or longer
  33. HOTSPOT_PASSPHRASE="${PROJECT_NAME}"
  34. source /usr/share/${PROJECT_NAME}/utils/${PROJECT_NAME}-utils-wifi
  35. if [[ $1 == "start" ]]; then
  36. # install avahi
  37. sed -i "s|#host-name=.*|host-name=$(hostname)|g" /etc/avahi/avahi-daemon.conf
  38. sed -i "s|host-name=.*|host-name=$(hostname)|g" /etc/avahi/avahi-daemon.conf
  39. sed -i "s|use-ipv4=.*|use-ipv4=yes|g" /etc/avahi/avahi-daemon.conf
  40. sed -i "s|use-ipv6=.*|use-ipv6=no|g" /etc/avahi/avahi-daemon.conf
  41. sed -i "s|#disallow-other-stacks=.*|disallow-other-stacks=yes|g" /etc/avahi/avahi-daemon.conf
  42. sed -i "s|hosts:.*|hosts: files mdns4_minimal dns mdns4 mdns|g" /etc/nsswitch.conf
  43. fi
  44. # Mesh definition
  45. WIFI_SSID='mesh'
  46. if [ -f $COMPLETION_FILE ]; then
  47. if grep -q "WIFI_SSID:" $COMPLETION_FILE; then
  48. WIFI_SSID=$(cat $COMPLETION_FILE | grep "WIFI_SSID:" | awk -F ':' '{print $2}')
  49. fi
  50. sed -i "s|WIFI_SSID:.*|WIFI_SSID:${WIFI_SSID}|g" $COMPLETION_FILE
  51. fi
  52. CELLID='any'
  53. CHANNEL=2
  54. HOTSPOT_CHANNEL=6
  55. if [ -f $COMPLETION_FILE ]; then
  56. if grep -q "Wifi channel:" $COMPLETION_FILE; then
  57. CHANNEL=$(cat $COMPLETION_FILE | grep "Wifi channel:" | awk -F ':' '{print $2}')
  58. fi
  59. sed -i "s|Wifi channel:.*|Wifi channel:${CHANNEL}|g" $COMPLETION_FILE
  60. fi
  61. ZERONET_PORT=15441
  62. IPFS_PORT=4001
  63. TOX_PORT=33445
  64. TRACKER_PORT=6969
  65. LIBREVAULT_PORT=42345
  66. TAHOELAFS_PORT=50213
  67. # Ethernet bridge definition (bridged to bat0)
  68. BRIDGE=br-mesh
  69. BRIDGE_HOTSPOT=br-hotspot
  70. IFACE=
  71. IFACE_SECONDARY=
  72. EIFACE=eth0
  73. WLAN_ADAPTORS=$(count_wlan)
  74. if [ $WLAN_ADAPTORS -eq 0 ]; then
  75. echo $'No wlan adaptors found'
  76. exit 0
  77. fi
  78. update_wifi_adaptors
  79. if [ ! $IFACE ]; then
  80. echo $'No wlan adaptor'
  81. exit 0
  82. fi
  83. if [ -e /etc/default/batctl ]; then
  84. . /etc/default/batctl
  85. fi
  86. function get_ipv4_wlan {
  87. echo $(ip -o -f inet addr show dev "$IFACE" | awk '{print $4}' | awk 'END {print}' | awk -F '/' '{print $1}')
  88. }
  89. function mesh_hotspot_ip_address {
  90. echo $(ip -o -f inet addr show dev "$BRIDGE" | awk '{print $4}' | awk 'END {print}' | awk -F '/' '{print $1}')
  91. }
  92. function global_rate_limit {
  93. if ! grep -q "tcp_challenge_ack_limit" /etc/sysctl.conf; then
  94. echo 'net.ipv4.tcp_challenge_ack_limit = 999999999' >> /etc/sysctl.conf
  95. else
  96. sed -i 's|net.ipv4.tcp_challenge_ack_limit.*|net.ipv4.tcp_challenge_ack_limit = 999999999|g' /etc/sysctl.conf
  97. fi
  98. sysctl -p -q
  99. }
  100. function status {
  101. batctl o
  102. }
  103. function stop {
  104. if [ -z "$IFACE" ]; then
  105. echo 'error: unable to find wifi interface, not enabling batman-adv mesh'
  106. return
  107. fi
  108. if [ "$EIFACE" ]; then
  109. brctl delif $BRIDGE bat0
  110. ifconfig $BRIDGE down || true
  111. ethernet_connected=$(cat /sys/class/net/$EIFACE/carrier)
  112. if [[ "$ethernet_connected" != "0" ]]; then
  113. systemctl stop hostapd
  114. brctl delif $BRIDGE $EIFACE
  115. ifconfig $EIFACE down -promisc
  116. fi
  117. brctl delbr $BRIDGE
  118. fi
  119. avahi-autoipd -k $BRIDGE
  120. avahi-autoipd -k $IFACE
  121. ifconfig bat0 down -promisc
  122. batctl if del $IFACE
  123. ifconfig $IFACE mtu 1500
  124. ifconfig $IFACE down
  125. iwconfig $IFACE mode managed
  126. if [ $IFACE_SECONDARY ]; then
  127. systemctl stop hostapd
  128. systemctl disable hostapd
  129. batctl if del $IFACE_SECONDARY
  130. ifconfig $IFACE_SECONDARY mtu 1500
  131. ifconfig $IFACE_SECONDARY down
  132. iwconfig $IFACE_SECONDARY mode managed
  133. fi
  134. rmmod batman-adv
  135. iptables -D INPUT -p tcp --dport $TRACKER_PORT -j ACCEPT
  136. iptables -D INPUT -p udp --dport $TRACKER_PORT -j ACCEPT
  137. iptables -D INPUT -p tcp --dport 80 -j ACCEPT
  138. iptables -D INPUT -p udp --dport 80 -j ACCEPT
  139. iptables -D INPUT -p tcp --dport 548 -j ACCEPT
  140. iptables -D INPUT -p udp --dport 548 -j ACCEPT
  141. iptables -D INPUT -p tcp --dport 5353 -j ACCEPT
  142. iptables -D INPUT -p udp --dport 5353 -j ACCEPT
  143. iptables -D INPUT -p tcp --dport 5354 -j ACCEPT
  144. iptables -D INPUT -p udp --dport 5354 -j ACCEPT
  145. iptables -D INPUT -p tcp --dport $ZERONET_PORT -j ACCEPT
  146. iptables -D INPUT -p udp --dport $ZERONET_PORT -j ACCEPT
  147. iptables -D INPUT -p tcp --dport $IPFS_PORT -j ACCEPT
  148. iptables -D INPUT -p udp --dport $IPFS_PORT -j ACCEPT
  149. iptables -D INPUT -p tcp --dport $TOX_PORT -j ACCEPT
  150. iptables -D INPUT -p udp --dport $TOX_PORT -j ACCEPT
  151. iptables -D INPUT -p tcp --dport $LIBREVAULT_PORT -j ACCEPT
  152. iptables -D INPUT -p udp --dport $LIBREVAULT_PORT -j ACCEPT
  153. iptables -D INPUT -p tcp --dport $TAHOELAFS_PORT -j ACCEPT
  154. # SSB/Scuttlebot/Patchwork
  155. iptables -D INPUT -p udp --dport 8008 -j ACCEPT
  156. iptables -D INPUT -p tcp --dport 8008 -j ACCEPT
  157. iptables -D INPUT -p udp --dport 8010 -j ACCEPT
  158. iptables -D INPUT -p tcp --dport 8010 -j ACCEPT
  159. # vpn over the internet
  160. iptables -D INPUT -p tcp --dport 653 -j ACCEPT
  161. iptables -D INPUT -p udp --dport 653 -j ACCEPT
  162. iptables -D INPUT -i ${EIFACE} -m state --state NEW -p tcp --dport 1194 -j ACCEPT
  163. iptables -D INPUT -i tun+ -j ACCEPT
  164. iptables -D FORWARD -i tun+ -j ACCEPT
  165. iptables -D FORWARD -i tun+ -o ${EIFACE} -m state --state RELATED,ESTABLISHED -j ACCEPT
  166. iptables -D FORWARD -i ${EIFACE} -o tun+ -m state --state RELATED,ESTABLISHED -j ACCEPT
  167. iptables -t nat -D POSTROUTING -s 10.8.0.0/24 -o ${EIFACE} -j MASQUERADE
  168. iptables -D OUTPUT -o tun+ -j ACCEPT
  169. echo 0 > /proc/sys/net/ipv4/ip_forward
  170. sed -i 's|net.ipv4.ip_forward=.*|net.ipv4.ip_forward=0|g' /etc/sysctl.conf
  171. systemctl restart network-manager
  172. }
  173. function verify {
  174. tempfile="$(mktemp)"
  175. batctl o > $tempfile
  176. if grep -q "disabled" $tempfile; then
  177. echo $'B.A.T.M.A.N. not enabled'
  178. rm $tempfile
  179. stop
  180. exit 726835
  181. fi
  182. echo $'B.A.T.M.A.N. is running'
  183. rm $tempfile
  184. }
  185. function assign_peer_address {
  186. for i in {1..6}; do
  187. number=$RANDOM
  188. let "number %= 255"
  189. octet=$(echo "obase=16;$number" | bc)
  190. if [ ${#octet} -lt 2 ]; then
  191. octet="0${octet}"
  192. fi
  193. if [ $i -gt 1 ]; then
  194. echo -n ":"
  195. fi
  196. echo -n "${octet}"
  197. done
  198. }
  199. function add_wifi_interface {
  200. ifname=$1
  201. ifssid=$WIFI_SSID
  202. if [ $2 ]; then
  203. ifssid=$2
  204. fi
  205. ifmode=ad-hoc
  206. if [ $3 ]; then
  207. ifmode=$3
  208. fi
  209. ifchannel=$CHANNEL
  210. if [ $4 ]; then
  211. ifchannel=$4
  212. fi
  213. ifconfig $ifname down
  214. ifconfig $ifname mtu 1532
  215. peermac=$(assign_peer_address)
  216. if [ ! $peermac ]; then
  217. echo $"Unable to obtain MAC address for $peermac on $ifname"
  218. return
  219. fi
  220. ifconfig $ifname hw ether $peermac
  221. echo $"$ifname assigned MAC address $peermac"
  222. iwconfig $ifname enc off
  223. iwconfig $ifname mode $ifmode essid $ifssid channel $ifchannel
  224. batctl if add $ifname
  225. ifconfig $ifname up
  226. }
  227. function mesh_create_app_downloads_page {
  228. if [ ! -d /root/$PROJECT_NAME/image_build/mesh_apps ]; then
  229. return
  230. fi
  231. if [ ! -d /var/www/html ]; then
  232. return
  233. fi
  234. cp /root/$PROJECT_NAME/website/EN/meshindex.html /var/www/html/index.html
  235. if [ ! -f /var/www/html/ssb.apk ]; then
  236. cp /root/$PROJECT_NAME/image_build/mesh_apps/ssb.apk /var/www/html/ssb.apk
  237. fi
  238. if [ ! -d /var/www/html/images ]; then
  239. mkdir /var/www/html/images
  240. fi
  241. if [ ! -f /var/www/html/images/logo.png ]; then
  242. cp /root/$PROJECT_NAME/img/logo.png /var/www/html/images/logo.png
  243. fi
  244. if [ ! -f /var/www/html/images/ssb.png ]; then
  245. cp /root/$PROJECT_NAME/img/icon_patchwork.png /var/www/html/images/ssb.png
  246. fi
  247. if [ ! -f /var/www/html/freedombone.css ]; then
  248. cp /root/$PROJECT_NAME/website/freedombone.css /var/www/html/freedombone.css
  249. fi
  250. chown -R www-data:www-data /var/www/html/*
  251. }
  252. function start {
  253. if [ -z "$IFACE" ] ; then
  254. echo 'error: unable to find wifi interface, not enabling batman-adv mesh'
  255. exit 723657
  256. fi
  257. echo "info: enabling batman-adv mesh network $WIFI_SSID on $IFACE"
  258. systemctl stop network-manager
  259. sleep 5
  260. # remove an avahi service which isn't used
  261. if [ -f /etc/avahi/services/udisks.service ]; then
  262. sudo rm /etc/avahi/services/udisks.service
  263. fi
  264. global_rate_limit
  265. # Might have to re-enable wifi
  266. rfkill unblock $(rfkill list|awk -F: "/phy/ {print $1}") || true
  267. secondary_wifi_available=
  268. if [ $IFACE_SECONDARY ]; then
  269. if [[ $IFACE != $IFACE_SECONDARY ]]; then
  270. if [ -d /etc/hostapd ]; then
  271. if [ ${#HOTSPOT_PASSPHRASE} -gt 4 ]; then
  272. secondary_wifi_available=1
  273. else
  274. echo $'Hotspot passphrase is too short'
  275. fi
  276. fi
  277. fi
  278. fi
  279. modprobe batman-adv
  280. add_wifi_interface $IFACE $WIFI_SSID ad-hoc $CHANNEL
  281. avahi-autoipd --force-bind --daemonize --wait $IFACE
  282. # NOTE: Don't connect the secondary wifi device. hostapd will handle that by itself
  283. ifconfig bat0 up promisc
  284. brctl addbr $BRIDGE
  285. brctl addif $BRIDGE bat0
  286. ifconfig bat0 0.0.0.0
  287. if [ "$EIFACE" ] ; then
  288. ethernet_connected=$(cat /sys/class/net/$EIFACE/carrier)
  289. if [[ "$ethernet_connected" != "0" ]]; then
  290. echo $'Trying ethernet bridge to the internet'
  291. brctl addif $BRIDGE $EIFACE
  292. ifconfig $EIFACE 0.0.0.0
  293. ifconfig $EIFACE up promisc
  294. echo $'End of ethernet bridge'
  295. else
  296. echo $"$EIFACE is not connected"
  297. fi
  298. fi
  299. ifconfig $BRIDGE up
  300. dhclient $BRIDGE
  301. if [ $secondary_wifi_available ]; then
  302. sed -i 's|#DAEMON_CONF=.*|DAEMON_CONF="/etc/hostapd/hostapd.conf"|g' /etc/default/hostapd
  303. echo "interface=${IFACE_SECONDARY}" > /etc/hostapd/hostapd.conf
  304. echo "bridge=${BRIDGE}" >> /etc/hostapd/hostapd.conf
  305. echo 'driver=nl80211' >> /etc/hostapd/hostapd.conf
  306. echo "country_code=UK" >> /etc/hostapd/hostapd.conf
  307. echo "ssid=${WIFI_SSID}-$(mesh_hotspot_ip_address)" >> /etc/hostapd/hostapd.conf
  308. echo 'hw_mode=g' >> /etc/hostapd/hostapd.conf
  309. echo "channel=${HOTSPOT_CHANNEL}" >> /etc/hostapd/hostapd.conf
  310. echo 'wpa=2' >> /etc/hostapd/hostapd.conf
  311. echo "wpa_passphrase=$HOTSPOT_PASSPHRASE" >> /etc/hostapd/hostapd.conf
  312. echo 'wpa_key_mgmt=WPA-PSK' >> /etc/hostapd/hostapd.conf
  313. echo 'wpa_pairwise=TKIP' >> /etc/hostapd/hostapd.conf
  314. echo 'rsn_pairwise=CCMP' >> /etc/hostapd/hostapd.conf
  315. echo 'auth_algs=1' >> /etc/hostapd/hostapd.conf
  316. echo 'macaddr_acl=0' >> /etc/hostapd/hostapd.conf
  317. systemctl enable hostapd
  318. systemctl restart hostapd
  319. mesh_create_app_downloads_page
  320. fi
  321. iptables -A INPUT -p icmp --icmp-type echo-request -j ACCEPT
  322. iptables -A OUTPUT -p icmp --icmp-type echo-reply -j ACCEPT
  323. iptables -A INPUT -p tcp --dport $TRACKER_PORT -j ACCEPT
  324. iptables -A INPUT -p udp --dport $TRACKER_PORT -j ACCEPT
  325. iptables -A INPUT -p tcp --dport 80 -j ACCEPT
  326. iptables -A INPUT -p udp --dport 80 -j ACCEPT
  327. iptables -A INPUT -p tcp --dport 548 -j ACCEPT
  328. iptables -A INPUT -p udp --dport 548 -j ACCEPT
  329. iptables -A INPUT -p tcp --dport 5353 -j ACCEPT
  330. iptables -A INPUT -p udp --dport 5353 -j ACCEPT
  331. iptables -A INPUT -p tcp --dport 5354 -j ACCEPT
  332. iptables -A INPUT -p udp --dport 5354 -j ACCEPT
  333. iptables -A INPUT -p tcp --dport $ZERONET_PORT -j ACCEPT
  334. iptables -A INPUT -p udp --dport $ZERONET_PORT -j ACCEPT
  335. iptables -A INPUT -p tcp --dport $IPFS_PORT -j ACCEPT
  336. iptables -A INPUT -p tcp --dport $TOX_PORT -j ACCEPT
  337. iptables -A INPUT -p udp --dport $TOX_PORT -j ACCEPT
  338. iptables -A INPUT -p tcp --dport $LIBREVAULT_PORT -j ACCEPT
  339. iptables -A INPUT -p udp --dport $LIBREVAULT_PORT -j ACCEPT
  340. iptables -A INPUT -p tcp --dport $TAHOELAFS_PORT -j ACCEPT
  341. # SSB/Scuttlebot/Patchwork
  342. iptables -A INPUT -p udp --dport 8008 -j ACCEPT
  343. iptables -A INPUT -p tcp --dport 8008 -j ACCEPT
  344. iptables -A INPUT -p udp --dport 8010 -j ACCEPT
  345. iptables -A INPUT -p tcp --dport 8010 -j ACCEPT
  346. # vpn over the internet
  347. iptables -A INPUT -p tcp --dport 653 -j ACCEPT
  348. iptables -A INPUT -p udp --dport 653 -j ACCEPT
  349. iptables -A INPUT -i ${EIFACE} -m state --state NEW -p tcp --dport 1194 -j ACCEPT
  350. iptables -A INPUT -i tun+ -j ACCEPT
  351. iptables -A FORWARD -i tun+ -j ACCEPT
  352. iptables -A FORWARD -i tun+ -o ${EIFACE} -m state --state RELATED,ESTABLISHED -j ACCEPT
  353. iptables -A FORWARD -i ${EIFACE} -o tun+ -m state --state RELATED,ESTABLISHED -j ACCEPT
  354. iptables -t nat -A POSTROUTING -s 10.8.0.0/24 -o ${EIFACE} -j MASQUERADE
  355. iptables -A OUTPUT -o tun+ -j ACCEPT
  356. echo 1 > /proc/sys/net/ipv4/ip_forward
  357. sed -i 's|# net.ipv4.ip_forward|net.ipv4.ip_forward|g' /etc/sysctl.conf
  358. sed -i 's|#net.ipv4.ip_forward|net.ipv4.ip_forward|g' /etc/sysctl.conf
  359. sed -i 's|net.ipv4.ip_forward.*|net.ipv4.ip_forward=1|g' /etc/sysctl.conf
  360. systemctl restart avahi-daemon
  361. if [ -f /etc/scuttlebot/.ssb/config ]; then
  362. ethernet_connected=$(cat /sys/class/net/eth0/carrier)
  363. if [[ "$ethernet_connected" != "0" ]]; then
  364. sed -i "s|\"host\": .*|\"host\": \"$(get_ipv4_wlan)\",|g" /etc/scuttlebot/.ssb/config
  365. systemctl restart scuttlebot
  366. else
  367. systemctl stop scuttlebot
  368. fi
  369. fi
  370. # if we have an ethernet connection to an internet router then create
  371. # an onion address for this peer
  372. if [[ "$ethernet_connected" != "0" ]]; then
  373. systemctl enable tor
  374. systemctl start tor
  375. HIDDEN_SERVICE_PATH=/var/lib/tor/hidden_service_
  376. if [ ! -f ${HIDDEN_SERVICE_PATH}mesh/hostname ]; then
  377. echo "HiddenServiceDir ${HIDDEN_SERVICE_PATH}mesh/" >> /etc/tor/torrc
  378. echo "HiddenServicePort 653 127.0.0.1:653" >> /etc/tor/torrc
  379. systemctl restart tor
  380. fi
  381. else
  382. systemctl stop tor
  383. systemctl disable tor
  384. fi
  385. verify
  386. }
  387. function monitor {
  388. if [ -z "$IFACE" ] ; then
  389. echo 'error: unable to find wifi interface, not enabling batman-adv mesh'
  390. exit 723657
  391. fi
  392. clear
  393. echo ''
  394. echo $'*** Stopping network ***'
  395. echo ''
  396. stop
  397. echo "info: monitoring mesh network $WIFI_SSID on $IFACE"
  398. systemctl stop network-manager
  399. sleep 5
  400. clear
  401. echo ''
  402. echo $'*** Setting firewall rate limit ***'
  403. echo ''
  404. global_rate_limit
  405. clear
  406. echo ''
  407. echo $'*** Enabling wifi adaptor in monitor mode ***'
  408. echo ''
  409. # Might have to re-enable wifi
  410. rfkill unblock $(rfkill list|awk -F: "/phy/ {print $1}") || true
  411. ifconfig $IFACE down
  412. ifconfig $IFACE mtu 1532
  413. ifconfig $IFACE hw ether $(assign_peer_address)
  414. iwconfig $IFACE enc off
  415. iwconfig $IFACE mode monitor channel $CHANNEL
  416. sleep 1
  417. iwconfig $IFACE ap $CELLID
  418. modprobe batman-adv
  419. batctl if add $IFACE
  420. ifconfig $IFACE up
  421. horst -i $IFACE
  422. clear
  423. echo ''
  424. echo $'*** Restarting the network daemon. This may take a while. ***'
  425. echo ''
  426. start
  427. }
  428. if ! grep -q "$IFACE" /proc/net/dev; then
  429. echo 'Interface $IFACE was not found'
  430. stop
  431. exit 1
  432. fi
  433. case "$1" in
  434. start|stop|status|monitor)
  435. $1
  436. ;;
  437. restart)
  438. clear
  439. echo ''
  440. echo $'*** Stopping mesh network connection ***'
  441. echo ''
  442. stop
  443. sleep 10
  444. clear
  445. echo ''
  446. echo $'*** Starting mesh network connection ***'
  447. echo ''
  448. start
  449. ;;
  450. ping)
  451. batctl ping $2
  452. ;;
  453. data)
  454. watch -n1 "batctl s | grep mgmt | grep bytes"
  455. ;;
  456. ls|list)
  457. avahi-browse -atl
  458. ;;
  459. *)
  460. echo "error: invalid parameter $1"
  461. echo 'usage: $0 {start|stop|restart|status|ping|ls|list}'
  462. exit 2
  463. ;;
  464. esac
  465. exit 0